<?php

header('Access-Control-Allow-Origin: *');
require_once("configuracao_mysql.php");

$id_usuario = substituir($connection, $_POST['id_usuario']);
$mes = substituir($connection, $_POST['mes']);
$ano = substituir($connection, $_POST['ano']);

echo '<div class="assinaturas_container">';
echo '    <div class="assinaturas">';
echo '        <h1>Meu plano</h1>';
echo '        <div class="plano_ativo">';

$query = "
    SELECT p.*, pl.plano
    FROM pedidos p
    JOIN planos pl ON p.id_plano = pl.id
    WHERE p.id_usuario = '$id_usuario' AND
    id_pagamento_status != 2
    LIMIT 1
";

$result = mysqli_query($connection, $query);

if (!$result) {
    die('Erro na consulta: ' . mysqli_error($connection));
}

if (mysqli_num_rows($result) > 0) {
    while ($row = mysqli_fetch_assoc($result)) {
        $plano = strtoupper($row['plano']);

        echo '            <div id="campo_plano">';
        echo '                <p id="automatico_cartao">' . htmlspecialchars($plano) . '</p>';
        echo '                <p id="ativo">';
        echo '                    <img src="img/pago.png" alt="Pago"> ATIVO';
        echo '                </p>';
        echo '            </div>';
    }
}

echo '            <button id="alterar_plano">ALTERAR PLANO</button>';
echo '        </div>';
echo '        <div id="troca_plano">';
echo '            <h2>Forma de pagamento</h2>';
echo '            <h2>Histórico de pagamento</h2>';
echo '            <div id="mes_ano">';
echo '                <div class="campos">';
echo '                    <label for="mes">Mês</label>';
echo '                    <input list="mes_enum" id="mes" name="mes" placeholder="Selecione" onblur="funcaoMes(this.value)">';
echo '                    <datalist id="mes_enum">';
echo '                        <option value="Janeiro"></option>';
echo '                        <option value="Fevereiro"></option>';
echo '                        <option value="Março"></option>';
echo '                        <option value="Abril"></option>';
echo '                        <option value="Maio"></option>';
echo '                        <option value="Junho"></option>';
echo '                        <option value="Julho"></option>';
echo '                        <option value="Agosto"></option>';
echo '                        <option value="Setembro"></option>';
echo '                        <option value="Outubro"></option>';
echo '                        <option value="Novembro"></option>';
echo '                        <option value="Dezembro"></option>';
echo '                    </datalist>';
echo '                </div>';
echo '                <div class="campos">';
echo '                    <label for="ano">Ano</label>';
echo '                    <input id="ano" name="ano" placeholder="Selecione" onblur="funcaoAno(this.value)">';
echo '                </div>';
echo '            </div>';
echo '            <div id="planos">';

$filter = "";

if ($mes && $ano) {
    $meses = [
        'Janeiro' => 1,
        'Fevereiro' => 2,
        'Março' => 3,
        'Abril' => 4,
        'Maio' => 5,
        'Junho' => 6,
        'Julho' => 7,
        'Agosto' => 8,
        'Setembro' => 9,
        'Outubro' => 10,
        'Novembro' => 11,
        'Dezembro' => 12
    ];

    $mes_numero = $meses[$mes] ?? 0;

    if ($mes_numero > 0) {
        $filter = "AND MONTH(p.data_vencimento) = '$mes_numero' AND YEAR(p.data_vencimento) = '$ano'";
    }
}

$query_planos = "
    SELECT p.*, ps.status, fp.forma_pagamento, pl.id_plano_tipo
    FROM pedidos p
    JOIN pagamento_status ps ON p.id_pagamento_status = ps.id
    JOIN forma_pagamento fp ON p.id_forma_pagamento = fp.id
    JOIN planos pl ON p.id_plano = pl.id
    WHERE p.id_usuario = '$id_usuario'
    $filter
    ORDER BY p.data_vencimento ASC
";

$result = mysqli_query($connection, $query_planos);

if (!$result) {
    die('Erro na consulta: ' . mysqli_error($connection));
}

if (mysqli_num_rows($result) > 0) {
    while ($row = mysqli_fetch_assoc($result)) {
        $id_plano_tipo = $row['id_plano_tipo'];
        $status = strtolower($row['status']);

        $query_planos_tipo = "
        SELECT tipo 
        FROM plano_tipos 
        WHERE id = '$id_plano_tipo'
        ";

        $result_planos_tipo = mysqli_query($connection, $query_planos_tipo);

        if (!$result_planos_tipo) {
            die('Erro na consulta: ' . mysqli_error($connection));
        }

        $row_plano = mysqli_fetch_assoc($result_planos_tipo);

        echo '                <div class="card_plano">';
        echo '                    <div class="campo_plano">';
        echo '                        <p>Data</p>';
        echo '                        <p>' . htmlspecialchars($row["data_vencimento"]) . '</p>';
        echo '                    </div>';
        echo '                    <div class="campo_plano">';
        echo '                        <p>Valor</p>';
        echo '                        <p>R$' . htmlspecialchars($row['valor']) . '</p>';
        echo '                    </div>';
        echo '                    <div class="campo_plano">';
        echo '                        <p>Plano</p>';
        echo '                        <p>' . htmlspecialchars($row_plano['tipo']) . '</p>';
        echo '                    </div>';
        echo '                    <div class="campo_plano">';
        echo '                        <p>Forma de pagamento</p>';
        echo '                        <p>' . htmlspecialchars($row['forma_pagamento']) . '</p>';
        echo '                    </div>';
        echo '                    <div class="campo_plano">';
        echo '                        <p>Status</p>';
        echo '                        <p id="' . htmlspecialchars($status) . '">';
        echo '                            <img src="img/' . htmlspecialchars($status) . '.png" alt="' . htmlspecialchars($status) . '"> ' . htmlspecialchars($row["status"]) . '';
        echo '                        </p>';
        echo '                    </div>';
        echo '                </div>';
    }
}
echo '            </div>';
echo '        </div>';
echo '    </div>';
echo '</div>';

?>