<?php
header('Access-Control-Allow-Origin: *');
header('Content-Type: application/json');

require_once("configuracao_mysql.php");

function isFileValid($file)
{
    return isset($file) && $file['error'] == UPLOAD_ERR_OK;
}

function moveFile($file, $upload_dir)
{
    $file_name = basename($file['name']);
    $file_tmp = $file['tmp_name'];
    $file_ext = strtolower(pathinfo($file_name, PATHINFO_EXTENSION));
    $unique_name = time() . '-' . uniqid() . '.' . $file_ext;
    $upload_path = $upload_dir . $unique_name;

    if (move_uploaded_file($file_tmp, $upload_path)) {
        return $unique_name;
    } else {
        throw new Exception("Erro ao mover o arquivo $file_name para o diretório $upload_dir");
    }
}

$response = [];

$email = Substituir($connection, $_POST['email']);
$senha = Substituir($connection, $_POST['senha']);
$nome = Substituir($connection, $_POST['nome']);
$data_nascimento = Substituir($connection, $_POST['data_nascimento']);
$cpf = Substituir($connection, $_POST['cpf']);
$rg = Substituir($connection, $_POST['rg']);
$genero = Substituir($connection, $_POST['genero']);
$celular_1 = Substituir($connection, $_POST['celular_1']);
$celular_2 = Substituir($connection, $_POST['celular_2']);
$cep = Substituir($connection, $_POST['cep']);
$bairro = Substituir($connection, $_POST['bairro']);
$uf = Substituir($connection, $_POST['estado']);
$cidade = Substituir($connection, $_POST['cidade']);
$id_tipo_usuario = Substituir($connection, $_POST['id_tipo_usuario']);
$complemento = Substituir($connection, $_POST['complemento']);
$endereco = Substituir($connection, $_POST['endereco']);
$numero = Substituir($connection, $_POST['numero']);

$cnh = Substituir($connection, $_POST['cnh']);
$tipo_veiculo = Substituir($connection, $_POST['tipo_veiculo']);
$marca = Substituir($connection, $_POST['marca']);
$modelo = Substituir($connection, $_POST['modelo']);
$ano = Substituir($connection, $_POST['ano']);
$motor = Substituir($connection, $_POST['motor']);
$placa = Substituir($connection, $_POST['placa']);
$sobre_mim = Substituir($connection, $_POST['sobre_mim']);
$outros = Substituir($connection, $_POST['outros']);
$raio = Substituir($connection, $_POST['raio']);

if (isset($_POST['crea'])) {
    $crea = Substituir($connection, $_POST['crea']);
} else {
    $crea = 0;
}

$meus_clientes = isset($_POST['meus_clientes']) ? $_POST['meus_clientes'] : '';
$atribuicoes = isset($_POST['atribuicoes']) ? $_POST['atribuicoes'] : '';
$tags = isset($_POST['tags']) ? $_POST['tags'] : '';

$array_tags = explode("#", $tags);
$array_atribuicoes = explode(",", $atribuicoes);
$array_meus_clientes = explode(",", $meus_clientes);

$disposicoes = isset($_POST['disposicoes']) ? $_POST['disposicoes'] : [];

$cpf_encrypt = encryptData($cpf, $key);
$rg_encrypt = encryptData($rg, $key);
$hashedPassword = password_hash($senha, PASSWORD_DEFAULT);

mysqli_begin_transaction($connection);

try {
    if (!is_dir('../arquivos')) {
        mkdir('../arquivos', 0777, true);
    }

    $sql = "INSERT INTO usuarios SET
            id_status = '1',
            id_usuario_tipo = '$id_tipo_usuario',
            nome = '$nome',
            data_nascimento = '$data_nascimento',
            cpf_cnpj = '$cpf_encrypt',
            rg_ie = '$rg_encrypt',
            crea = '$crea',
            id_genero = '$genero',
            celular_1 = '$celular_1',
            celular_2 = '$celular_2',
            email = '$email',
            senha = '$hashedPassword',
            cep = '$cep',
            endereco = '$endereco',
            numero = '$numero',
            complemento = '$complemento',
            bairro = '$bairro',
            cidade = '$cidade',
            uf = '$uf',
            data_cadastro = NOW()";

    if (!mysqli_query($connection, $sql)) {
        throw new Exception("Erro ao cadastrar usuário: " . mysqli_error($connection));
    }

    $id_usuario = mysqli_insert_id($connection);

    $sql = "INSERT INTO usuario_veiculos SET
            id_usuario = '$id_usuario',
            id_veiculo_tipo = '$tipo_veiculo',
            marca_veiculo = '$marca',
            modelo_veiculo = '$modelo',
            ano_veiculo = '$ano',
            motor_veiculo = '$motor',
            placa_veiculo = '$placa'";

    if (!mysqli_query($connection, $sql)) {
        throw new Exception("Erro ao cadastrar veículo: " . mysqli_error($connection));
    }

    $sql = "INSERT INTO usuario_perfis SET
            id_usuario = '$id_usuario',
            cnh = '$cnh',
            sobre_mim = '$sobre_mim',
            outro = '$outros',
            raio_atuacao = '$raio'";

    if (!mysqli_query($connection, $sql)) {
        throw new Exception("Erro ao cadastrar perfil profissional: " . mysqli_error($connection));
    }

    foreach ($_FILES as $key => $file) {
        if (isFileValid($file)) {
            $upload_dir = '../arquivos/';
            $file_name = moveFile($file, $upload_dir);

            switch ($key) {
                case 'foto_perfil':
                    $query = "UPDATE usuario_perfis SET foto_perfil = '$file_name' WHERE id_usuario = '$id_usuario'";
                    break;
                case 'foto_veiculo':
                    $query = "UPDATE usuario_veiculos SET foto = '$file_name' WHERE id_usuario = '$id_usuario'";
                    break;
                case 'foto_documentos':
                case 'foto_acessorios':
                case 'foto_servicos':
                    $codigo = ($key === 'foto_servicos') ? '1' : (($key === 'foto_acessorios') ? '2' : '3');
                    $query = "INSERT INTO usuario_imagens (id_usuario, id_imagem_tipo, imagem) VALUES ('$id_usuario', '$codigo', '$file_name')";
                    break;
                default:
                    throw new Exception("Chave de imagem desconhecida: $key");
            }

            if (!mysqli_query($connection, $query)) {
                throw new Exception("Erro ao salvar imagem no banco de dados: " . mysqli_error($connection));
            }
        } else {
            throw new Exception("Erro no upload do arquivo: " . $file['error']);
        }
    }

    if (empty($disposicoes)) {
        throw new Exception("Nenhuma disposição selecionada.");
    }

    foreach ($disposicoes as $disposicao) {
        $disposicao_sanitizada = Substituir($connection, $disposicao);
        $sql = "INSERT INTO usuario_disposicoes (id_usuario, disposicao) VALUES ('$id_usuario', '$disposicao_sanitizada')";

        if (!mysqli_query($connection, $sql)) {
            throw new Exception("Erro ao cadastrar disposição: " . mysqli_error($connection));
        }
    }

    foreach ($array_atribuicoes as $atribuicao) {
        $atribuicao_sanitizada = Substituir($connection, trim($atribuicao));
        $sql = "INSERT INTO usuario_atribuicoes SET id_usuario = '$id_usuario', atribuicao = '$atribuicao_sanitizada'";

        if (!mysqli_query($connection, $sql)) {
            throw new Exception("Erro ao cadastrar atribuição: " . mysqli_error($connection));
        }
    }

    foreach ($array_atribuicoes as $atribuicao) {
        $atribuicao_sanitizada = Substituir($connection, trim($atribuicao));

        if ($atribuicao_sanitizada != '') {

            $sql = "INSERT INTO usuario_atribuicoes SET id_usuario = '$id_usuario', atribuicao = '$atribuicao_sanitizada'";

            if (!mysqli_query($connection, $sql)) {
                throw new Exception("Erro ao cadastrar atribuição: " . mysqli_error($connection));
            }
        }

    }

    foreach ($array_tags as $tag) {
        $tag_sanitizada = Substituir($connection, trim($tag));

        if ($tag_sanitizada != '') {
            $sql = "INSERT INTO usuario_tags SET id_usuario = '$id_usuario', tag = '$tag_sanitizada'";

            if (!mysqli_query($connection, $sql)) {
                throw new Exception("Erro ao cadastrar tag: " . mysqli_error($connection));
            }
        }

    }

    foreach ($array_meus_clientes as $cliente) {
        $cliente_sanitizado = Substituir($connection, trim($cliente));

        if ($cliente_sanitizado != '') {
            $sql_check = "SELECT id FROM clientes WHERE cliente = '$cliente_sanitizado'";
            $result_check = mysqli_query($connection, $sql_check);

            if (!$result_check) {
                throw new Exception("Erro ao verificar cliente: " . mysqli_error($connection));
            }

            // if (mysqli_num_rows($result_check) == 0) {
            //     $sql_insert = "INSERT INTO clientes (cliente) VALUES ('$cliente_sanitizado')";
            //     if (!mysqli_query($connection, $sql_insert)) {
            //         throw new Exception("Erro ao cadastrar cliente: " . mysqli_error($connection));
            //     }
            // }

            $sql_user_client = "INSERT INTO usuario_clientes (id_usuario, id_cliente) VALUES ('$id_usuario', (SELECT id FROM clientes WHERE cliente = '$cliente_sanitizado'))";
            if (!mysqli_query($connection, $sql_user_client)) {
                throw new Exception("Erro ao vincular cliente ao usuário: " . mysqli_error($connection));
            }
        }

    }

    $sql_plano = "INSERT INTO pedidos SET 
        id_pagamento_status = '1',
        id_plano = '2',
        id_usuario = '$id_usuario',
        id_forma_pagamento = '6',
        valor = '0.0',
        data = NOW(),
        data_vencimento = DATE_ADD(NOW(), INTERVAL 1 MONTH)";

    if (!mysqli_query($connection, $sql_plano)) {
        throw new Exception("Erro ao inserir plano: " . mysqli_error($connection));
    }



    mysqli_commit($connection);

    $response = [
        "status" => "200",
        "id" => $id_usuario,
        "message" => "Usuário e dados relacionados cadastrados com sucesso!"
    ];

} catch (Exception $e) {
    mysqli_rollback($connection);
    $response = [
        "status" => "500",
        "message" => $e->getMessage()
    ];
}

echo json_encode($response);
mysqli_close($connection);
?>