<?php

header('Access-Control-Allow-Origin: *');
require_once("configuracao_mysql.php");

$busca = mysqli_real_escape_string($connection, $_POST['busca']);
$tipo = isset($_POST['tipo']) ? mysqli_real_escape_string($connection, $_POST['tipo']) : '';
$estados = isset($_POST['estados']) ? $_POST['estados'] : [];

error_log("Estados recebidos: " . print_r($estados, true));

$estados_escapados = array_map(function ($estado) use ($connection) {
    return mysqli_real_escape_string($connection, $estado);
}, $estados);
$estados_str = implode("','", $estados_escapados);

$query = "
    SELECT u.id AS usuario_id, u.nome, u.cidade, u.uf, GROUP_CONCAT(ua.atribuicao SEPARATOR ', ') AS atribuicoes
    FROM usuarios u
    LEFT JOIN usuario_atribuicoes ua ON u.id = ua.id_usuario
    WHERE u.id_usuario_tipo = '$busca'
";

if (!empty($tipo)) {
    $query .= " AND ua.atribuicao LIKE '%$tipo%'";
}

if (!empty($estados)) {
    $query .= " AND u.uf IN ('$estados_str')";
}

$query .= " GROUP BY u.id";

$result = mysqli_query($connection, $query);

$response = '';

if (mysqli_num_rows($result) > 0) {
    while ($row = mysqli_fetch_assoc($result)) {
        $nome_completo = htmlspecialchars($row["nome"], ENT_QUOTES, 'UTF-8');
        $nomes = explode(" ", $nome_completo);
        $primeiro_nome = $nomes[0];
        $ultimo_nome = end($nomes);
        $primeira_letra_ultimo_nome = strtoupper($ultimo_nome[0]) . '.'; // Primeira letra do último nome seguido de ponto
        $nome_resumido = $primeiro_nome . ' ' . $primeira_letra_ultimo_nome;

        $tipo_usuario = !empty($tipo) ? htmlspecialchars($tipo, ENT_QUOTES, 'UTF-8') : htmlspecialchars($row['atribuicao'], ENT_QUOTES, 'UTF-8');

        $response .= '<div id="profissionais">
                        <p>' . $nome_resumido . '</p>
                        <p>' . $tipo_usuario . '</p>
                        <p>' . htmlspecialchars($row['cidade'], ENT_QUOTES, 'UTF-8') . '-' . htmlspecialchars($row['uf'], ENT_QUOTES, 'UTF-8') . '</p>
                        <button id="ver_dados" onclick="window.location.href=\'dados-sobre-mim.html?id=' . $row['usuario_id'] . '&uf=' . $row['uf'] . '\'">VER DADOS</button>
                      </div>';
    }
} else {
    $response = '<p style="color: #fff; margin-left: 80px">Nenhum Usuário Encontrado</p>';
}

echo $response;

?>