<?php
header('Access-Control-Allow-Origin: *');
header('Content-Type: application/json');

require_once("configuracao_mysql.php");

function isFileValid($file)
{
    return isset($file) && $file['error'] == UPLOAD_ERR_OK;
}

function moveFile($file, $upload_dir)
{
    $file_name = basename($file['name']);
    $file_tmp = $file['tmp_name'];
    $file_ext = strtolower(pathinfo($file_name, PATHINFO_EXTENSION));
    $unique_name = time() . '-' . uniqid() . '.' . $file_ext;
    $upload_path = $upload_dir . $unique_name;

    if (move_uploaded_file($file_tmp, $upload_path)) {
        return $unique_name;
    } else {
        throw new Exception("Erro ao mover o arquivo $file_name para o diretório $upload_dir");
    }
}

$response = [];
$id_usuario = isset($_POST['id_usuario']) ? Substituir($connection, $_POST['id_usuario']) : null;
$email = Substituir($connection, $_POST['email']);
$senha = Substituir($connection, $_POST['senha']);
$nome = Substituir($connection, $_POST['nome']);
$data_nascimento = Substituir($connection, $_POST['data_nascimento']);
$cpf = Substituir($connection, $_POST['cpf']);
$rg = Substituir($connection, $_POST['rg']);
$genero = Substituir($connection, $_POST['genero']);
$celular_1 = Substituir($connection, $_POST['celular_1']);
$celular_2 = Substituir($connection, $_POST['celular_2']);
$cep = Substituir($connection, $_POST['cep']);
$bairro = Substituir($connection, $_POST['bairro']);
$uf = Substituir($connection, $_POST['estado']);
$cidade = Substituir($connection, $_POST['cidade']);
$complemento = Substituir($connection, $_POST['complemento']);
$endereco = Substituir($connection, $_POST['endereco']);
$numero = Substituir($connection, $_POST['numero']);

$cpf_encrypt = encryptData($cpf, $key);
$rg_encrypt = encryptData($rg, $key);
$hashedPassword = password_hash($senha, PASSWORD_DEFAULT);

mysqli_begin_transaction($connection);

try {
    if (!is_dir('../arquivos')) {
        mkdir('../arquivos', 0777, true);
    }

    $sql = "UPDATE usuarios SET
                id_status = '1',
                nome = '$nome',
                data_nascimento = '$data_nascimento',
                cpf_cnpj = '$cpf_encrypt',
                rg_ie = '$rg_encrypt',
                crea = '0',
                id_genero = '$genero',
                celular_1 = '$celular_1',
                celular_2 = '$celular_2',
                email = '$email',
                senha = '$hashedPassword',
                cep = '$cep',
                endereco = '$endereco',
                numero = '$numero',
                complemento = '$complemento',
                bairro = '$bairro',
                cidade = '$cidade',
                uf = '$uf',
                data_cadastro = NOW()
                WHERE id= '$id_usuario'";


    if (!mysqli_query($connection, $sql)) {
        throw new Exception("Erro ao atualizar/inserir usuário: " . mysqli_error($connection));
    }

    foreach ($_FILES as $key => $file) {
        if (isFileValid($file)) {
            $upload_dir = '../arquivos/';
            $file_name = moveFile($file, $upload_dir);

            switch ($key) {
                case 'foto_perfil':
                    $query = $id_usuario
                        ? "UPDATE usuario_perfis SET foto_perfil = '$file_name' WHERE id_usuario = '$id_usuario'"
                        : "INSERT INTO usuario_perfis (id_usuario, foto_perfil) VALUES ('$id_usuario', '$file_name')";
                    break;
            }

            if (!mysqli_query($connection, $query)) {
                throw new Exception("Erro ao salvar imagem no banco de dados: " . mysqli_error($connection));
            }
        } else {
            throw new Exception("Erro no upload do arquivo: " . $file['error']);
        }
    }

    mysqli_commit($connection);

    $response = [
        "status" => "200",
        "message" => $id_usuario ? "Usuário atualizado com sucesso!" : "Usuário cadastrado com sucesso!"
    ];

} catch (Exception $e) {
    mysqli_rollback($connection);
    $response = [
        "status" => "500",
        "message" => $e->getMessage()
    ];
}

echo json_encode($response);
mysqli_close($connection);
?>