<?php
header('Access-Control-Allow-Origin: *');
header('Content-Type: application/json');

require_once("configuracao_mysql.php");

function isFileValid($file)
{
    return isset($file) && $file['error'] == UPLOAD_ERR_OK;
}

function moveFile($file, $upload_dir)
{
    $file_name = basename($file['name']);
    $file_tmp = $file['tmp_name'];
    $file_ext = strtolower(pathinfo($file_name, PATHINFO_EXTENSION));
    $unique_name = time() . '-' . uniqid() . '.' . $file_ext;
    $upload_path = $upload_dir . $unique_name;

    if (move_uploaded_file($file_tmp, $upload_path)) {
        return $unique_name;
    } else {
        throw new Exception("Erro ao mover o arquivo $file_name para o diretório $upload_dir");
    }
}

$response = [];

$id_usuario = Substituir($connection, $_POST['id_usuario']);
$cnh = Substituir($connection, $_POST['cnh']);
$tipo_veiculo = Substituir($connection, $_POST['tipo_veiculo']);
$marca = Substituir($connection, $_POST['marca']);
$modelo = Substituir($connection, $_POST['modelo']);
$ano = Substituir($connection, $_POST['ano']);
$motor = Substituir($connection, $_POST['motor']);
$placa = Substituir($connection, $_POST['placa']);
$sobre_mim = Substituir($connection, $_POST['sobre_mim']);
$outros = Substituir($connection, $_POST['outros']);
$raio = Substituir($connection, $_POST['raio']);

$meus_clientes = isset($_POST['meus_clientes']) ? $_POST['meus_clientes'] : '';
$atribuicoes = isset($_POST['atribuicoes']) ? $_POST['atribuicoes'] : '';
$tags = isset($_POST['tags']) ? $_POST['tags'] : '';

$array_tags = explode("#", $tags);
$array_atribuicoes = explode(",", $atribuicoes);
$array_meus_clientes = explode(",", $meus_clientes);

$disposicoes = isset($_POST['disposicoes']) ? $_POST['disposicoes'] : [];

mysqli_begin_transaction($connection);

try {
    if (!is_dir('../arquivos')) {
        mkdir('../arquivos', 0777, true);
    }

    $sql = "UPDATE usuario_veiculos SET
            id_veiculo_tipo = '$tipo_veiculo',
            marca_veiculo = '$marca',
            modelo_veiculo = '$modelo',
            ano_veiculo = '$ano',
            motor_veiculo = '$motor',
            placa_veiculo = '$placa'
            WHERE id_usuario = '$id_usuario'";

    if (!mysqli_query($connection, $sql)) {
        throw new Exception("Erro ao atualizar veículo: " . mysqli_error($connection));
    }

    $sql = "UPDATE usuario_perfis SET
            cnh = '$cnh',
            sobre_mim = '$sobre_mim',
            outro = '$outros',
            raio_atuacao = '$raio'
            WHERE id_usuario = '$id_usuario'";

    if (!mysqli_query($connection, $sql)) {
        throw new Exception("Erro ao atualizar perfil profissional: " . mysqli_error($connection));
    }

    foreach ($_FILES as $key => $file) {
        if (isFileValid($file)) {
            $upload_dir = '../arquivos/';
            $file_name = moveFile($file, $upload_dir);

            switch ($key) {
                case 'foto_veiculo':
                    $query = "UPDATE usuario_veiculos SET foto = '$file_name' WHERE id_usuario = '$id_usuario'";
                    break;
                case 'foto_documentos':
                case 'foto_acessorios':
                case 'foto_servicos':
                    $codigo = ($key === 'foto_servicos') ? '1' : (($key === 'foto_acessorios') ? '2' : '3');
                    $query = "UPDATE usuario_imagens SET imagem = '$file_name' WHERE id_usuario = '$id_usuario' AND id_imagem_tipo = '$codigo'";
                    break;
                default:
                    throw new Exception("Chave de imagem desconhecida: $key");
            }

            if (!mysqli_query($connection, $query)) {
                throw new Exception("Erro ao atualizar imagem no banco de dados: " . mysqli_error($connection));
            }
        } else {
            throw new Exception("Erro no upload do arquivo: " . $file['error']);
        }
    }

    if (empty($disposicoes)) {
        throw new Exception("Nenhuma disposição selecionada.");
    }

    $sql = "DELETE FROM usuario_disposicoes WHERE id_usuario = '$id_usuario'";
    if (!mysqli_query($connection, $sql)) {
        throw new Exception("Erro ao remover disposições antigas: " . mysqli_error($connection));
    }

    foreach ($disposicoes as $disposicao) {
        $disposicao_sanitizada = Substituir($connection, $disposicao);
        $sql = "INSERT INTO usuario_disposicoes (id_usuario, disposicao) VALUES ('$id_usuario', '$disposicao_sanitizada')";

        if (!mysqli_query($connection, $sql)) {
            throw new Exception("Erro ao cadastrar disposição: " . mysqli_error($connection));
        }
    }

    $sql = "DELETE FROM usuario_atribuicoes WHERE id_usuario = '$id_usuario'";
    if (!mysqli_query($connection, $sql)) {
        throw new Exception("Erro ao remover atribuições antigas: " . mysqli_error($connection));
    }

    foreach ($array_atribuicoes as $atribuicao) {
        $atribuicao_sanitizada = Substituir($connection, trim($atribuicao));
        if ($atribuicao_sanitizada != '') {
            $sql = "INSERT INTO usuario_atribuicoes (id_usuario, atribuicao) VALUES ('$id_usuario', '$atribuicao_sanitizada')";

            if (!mysqli_query($connection, $sql)) {
                throw new Exception("Erro ao cadastrar atribuição: " . mysqli_error($connection));
            }
        }
    }

    $sql = "DELETE FROM usuario_tags WHERE id_usuario = '$id_usuario'";
    if (!mysqli_query($connection, $sql)) {
        throw new Exception("Erro ao remover tags antigas: " . mysqli_error($connection));
    }

    foreach ($array_tags as $tag) {
        $tag_sanitizada = Substituir($connection, trim($tag));
        if ($tag_sanitizada != '') {
            $sql = "INSERT INTO usuario_tags (id_usuario, tag) VALUES ('$id_usuario', '$tag_sanitizada')";

            if (!mysqli_query($connection, $sql)) {
                throw new Exception("Erro ao cadastrar tag: " . mysqli_error($connection));
            }
        }
    }

    $sql = "DELETE FROM usuario_clientes WHERE id_usuario = '$id_usuario'";
    if (!mysqli_query($connection, $sql)) {
        throw new Exception("Erro ao remover clientes antigos: " . mysqli_error($connection));
    }

    foreach ($array_meus_clientes as $cliente) {
        $cliente_sanitizado = Substituir($connection, trim($cliente));
        if ($cliente_sanitizado != '') {
            $sql_check = "SELECT id FROM clientes WHERE cliente = '$cliente_sanitizado'";
            $result_check = mysqli_query($connection, $sql_check);

            if (!$result_check) {
                throw new Exception("Erro ao verificar cliente: " . mysqli_error($connection));
            }

            $cliente_id = mysqli_fetch_assoc($result_check)['id'];

            $sql_user_client = "INSERT INTO usuario_clientes (id_usuario, id_cliente) VALUES ('$id_usuario', '$cliente_id')";
            if (!mysqli_query($connection, $sql_user_client)) {
                throw new Exception("Erro ao vincular cliente ao usuário: " . mysqli_error($connection));
            }
        }
    }

    mysqli_commit($connection);

    $response = [
        "status" => "200",
        "message" => "Usuário e dados relacionados atualizados com sucesso!"
    ];

} catch (Exception $e) {
    mysqli_rollback($connection);
    $response = [
        "status" => "500",
        "message" => $e->getMessage()
    ];
}

echo json_encode($response);
mysqli_close($connection);
?>